     000       JOB  1401 TWO-TAPE AUTOCODER, PHASE 3 - JULY 30, 1962 RBR   2TAP3
               CTL  630 1
     *
     ******    PHASE 3 - BUILD UP SYMBOL TABLE AND PROCESS LITERALS  ***
     *
     *                        ***  PHASE 3 IDENTIFICATION AT 333  ***
     *
               ORG  333
               DCW  @3@
     *
     *
               ORG  82
     CHECK     DCW  @ @
               DCW  @  }@
     X1        EQU  89
     0089      DCW  @000@
     X2        EQU  94
     0094      DCW  @000@
     X3        EQU  99
     0099      DCW  @000@
     HLDLOC    EQU  3
     SAVLOC    EQU  6
     LASTLT    EQU  9
     LTTSAV    EQU  12
     TBLLMT    EQU  15
     REITER    EQU  193
     FULL      EQU  194
     LITCTL    EQU  195
     RELATV    EQU  196
     DA        EQU  197
               ORG  100
     LOAD      RWD  1
               RTW  1,CHECK
               BER  TPERR
               BCE  *&5,CHECK,D
               B    LOAD&5
               BSP  1
               RTW  1,333
               SW   CHECK&3
               RTW  1,CHECK
               BCE  334,CHECK,9
               B    *-19
     SEEK      EQU  LOAD&25            NUMBER OF PHASE REQUESTED
     SYSTEM    WTW  1,333
               BER  *&5
               R    40
               BSP  1
               SKP  1
               B    SYSTEM
               H
     OVFLIT    EQU  14
               ORG  3971
               ORG  3943
     SENTNL    BCE  REWRIT,333,1
               BCE  REWRIT,333,3
               BCE  REWRIT,333,7
               B    334
     REWRIT    BSP  1
               WTW  1,CHECK
               BER  TPERR
               BCE  334,CHECK,%
               H
               ORG  201
     *                        LINKAGE TO GENERALIZED TAPE ERROR ROUTINE
     TPERR     H
     LABEL     EQU  RECORD&10
     *
     *
     *                            ** 2TAP2 SUBROUTINES **
     *
               ORG  ZONE&5
     *                        ROUTINE TO PUT A SYMBOL IN THE LABEL TABLE
     *                           * SYMBOL TAKEN FROM LABEL IN RECORD
     *                           * CURRENT AVAILABLE TABLE LOCATION IS
     *                             INDEXED BY X3
     *                           * IF LABEL TABLE IS FULL,LABEL IS NOT
     *                             STORED, AND A W/M IS SET AT RECORD&1
     SETLAB    SBR  SETEXT&3
               NOP  TBLOVF,FULL,1
               MLC  LOCCTR,LABTBL&X3
               MLC  LABEL,LABTBL-3&X3
               NOP  000,000,0
               NOP  000
     TSTLMT    A    @9@,X3
               C    TBLLMT,X3
               BU   TBLOVF&7
               B    TBLOVF
     SETEXT    B    0
     TBLOVF    SW   FULL,RECORD&1
               LCA  LITTOT,LTTSAV
               B    LOADXX
     *                        ROUTINE TO LOOK UP LABEL IN LABEL TABLE
     *                           * ARGUMENT LABEL PLACED AT LABTBL-3&X3
     *                           * IF LABEL FOUND, RETURN BY EXIT
     *                           * IF NOT FOUND, RETURN BY EXIT&4
     *                           * HIT LOCATED BY X2
     TLULAB    SBR  TLUEXT&3
               MLC  @000@,X2
               SW   TLUFST&7
               MLC  LABTBL-7&X3,TLUFST&7
               CW   TLUFST&7
     TLUFST    BCE  HITFST,LABTBL-7&X2,
               A    @9@,X2
               B    TLUFST
     HITFST    C    LABTBL-3&X2,LABTBL-3&X3
               BU   TLUFST&8
               CW   LABTBL-8&X3
               C    X2,X3
               BU   TLUEXT
               SW   TLUEXT&1
               A    @4@,TLUEXT&3
               CW   TLUEXT&1
     TLUEXT    B    0
     *                        ROUTINE TO MODIFY A MACHINE ADDRESS BY A
     *                             PLUS OR MINUS ADJUSTMENT VALUE
     *                           * ADDRESS PLACED AT ADDR
     *                           * ADJUSTMENT VALUE TAKEN FROM PARAMT&10
     *                           * MODIFIED ADDRESS SET AT RESULT-1
     MODADD    SBR  MODEXT&3
               BAV  *&1
               CW   NEG
               SW   PARAMT&11
               MLC  @000@,X1
               MLC  PARAMT&19,X1
               MLC  @000@,HOLD
               MLC  PARAMT&10&X1,HOLD
               MZ   PARAMT&10,HOLD
               BM   DECR,HOLD
     SETINC    MLC  ADDR,RESULT-1
               MZ   @ @,RESULT-1
               A    HOLD,RESULT-1
               MZ   ADDR,RESULT-1
               MZ   RESULT-3,YYY
               MZ   ADDR-2,XXX
               BW   MODEXT&4,NEG
               C    XXX,YYY
               BH   *&5
               B    MODEXT
               SW   RESULT-1
               A    @|0@,RESULT
               CW   RESULT-1
     MODEXT    B    000
               BAV  MODEXT
               C    XXX,YYY
               BH   MODEXT
               SW   RESULT-1
               A    @?0@,RESULT
               B    MODEXT-4
     XXX       DCW  @2@
     YYY       DCW  @2@
     DECR      SW   NEG
               A    @999@,HOLD
               A    @?01@,HOLD
               B    SETINC
     MODALT    SBR  MODEXT&3
               BAV  *&1
               CW   NEG
               B    SETINC-16
     MODZER    MLC  HOLD,RESULT-1
               B    MODEXT
     HALT4     H
     *
     *                        HOUSEKEEPING
     *
               ORG  334
               B    HSKPG             PIVOT BRANCH TO HOUSEKEEPING
     *                        CREATE ALL WORK AREAS - OVERLAID BY INSTRS
               NOP  LOCCTR#3,LITTOT#3
               NOP  ADDR#3,HOLD#3
               NOP  RESULT#4
               NOP  LITORG#1,NEG#1
     *                        GET INPUT RECORD
               ORG  338
     GETRCD    RTW  2,RECORD
               BER  TPERR
               BEF  IPEOR
               B    PUTRCD&7,LABEL-5,*      BYPASS COMMENTS CARD
               SW   LABEL-5
               BW   PUTRCD&7,RECORD&3
               BW   GETLOC,RECORD&1
               BW   CNTRL2,FULL
     PROCES    BW   SUBSEQ,DA
     INSTR     BW   CNTRL,RECORD       TEST FOR CONTROL STATEMENT
               BCE  DECLAR,ICOUNT,
     *                        PROCESS IMPERATIVE COMMAND
     IMPER     BCE  *&13,LABEL-5,
               BWZ  PRCLIT,LABEL-5,2   BYPASS ACTUAL LOCATION ASSIGNMENT
               B    SETLAB
               LCA  LOCCTR,LOCATN
               ZA   ICOUNT,HOLD        STEP LOCATION COUNTER BY LENGTH
               MZ   @ @,HOLD
               MLC  LOCCTR,ADDR
               B    MODALT
               MLC  RESULT-1,LOCCTR
               BCE  PUTRCD,LITCNT,
     *                        TEST FOR LITERALS
     PRCLIT    MLC  @000@,X1
               BCE  LITERL,AADDR,L     NUMERIC LITERAL
               BCE  ALFLIT,AADDR,F     ALPHANUMERIC LITERAL
               BCE  AREA,AADDR,W       LITERAL AREA
               BCE  ADCON,AADDR,C      ADDRESS CONSTANT
               MLC  @030@,X1
               BCE  LITERL,BADDR,L     NUMERIC LITERAL
               BCE  ALFLIT,BADDR,F     ALPHANUMERIC LITERAL
               BCE  AREA,BADDR,W       LITERAL AREA
               BCE  ADCON,BADDR,C      ADDRESS CONSTANT
     *                        PUT OUTPUT RECORD
     PUTRCD    LCA  LOCCTR,HLDLOC
               WTW  1,RECORD
               BER  TPERR
               BEF  *&1
               B    GETRCD
     *                        PROCESS DECLARATIVE STATEMENTS
     *
     GETLOC    MLC  HLDLOC,LOCCTR
               CW   FULL,RECORD&1
               B    MOVXX
     *
     CNTRL2    BW   *&5,RECORD
               B    PUTRCD&7
               BCE  PUTRCD&7,PARAMT,*
               BCE  CNTRL,AADDR,S
               B    PUTRCD&7
     *
     DECLAR    C    OPER,@DA  @
               BE   DALINE
               MLC  LITCNT,HOLD
               S    @1@,HOLD           STEP LOCATION COUNTER BY LENGTH-1
               MZ   @ @,HOLD
               MLC  LOCCTR,ADDR
               B    MODALT
               BCE  *&9,LABEL-5,
               BWZ  PUTRCD,LABEL-5,2   TEST FOR ACTUAL ADDRESS ASSNMT
               MLC  RESULT-1,LOCCTR
               MLC  LOCCTR,LOCATN
               BCE  *&5,LABEL-5,
               B    SETLAB             STORE LABEL & LOCATION IN TABLE
     UPDLOC    ZA   LITCNT,HOLD
               MZ   @ @,HOLD
               B    MODALT             STEP LOCATION COUNTER BY LENGTH
               MLC  RESULT-1,LOCCTR
               B    PUTRCD
     *                        PROCESS DA HEADER
     DALINE    LCA  LOCCTR,SAVLOC
               SW   DA
               MZ   ACTOP,LOCCTR-1     GET INDEXING FOR LABTBL
               MLC  SAVLOC,ADDR
               BCE  *&13,LABEL-5,
               BWZ  ACTDA,LABEL-5,2
               B    SETLAB
               MLC  SAVLOC,LOCATN
               MLC  LITCNT,SAVLOC      SAVE TOTAL LENGTH OF DA
               B    PUTRCD
     *              DA ENTRY WITH ACTUAL ADDRESS ASSIGNMENT
     ACTDA     MLC  LOCATN,ADDR
               SW   ACTDA&1            SET ACT. ADDR. SWITCH
               B    PUTRCD
     *              PROCESS SUBSEQUENT ENTRIES FOR DA
     SUBSEQ    BW   DASUB,PARAMT&65    TEST FOR DA SUBSEQUENT ENTRY
               BW   ACTOUT,ACTDA&1     NOT SUBSEQ - TEST ACTUAL ADDR SW
               MLC  SAVLOC,HOLD
               B    MODALT
               MLC  RESULT-1,LOCCTR   STEP LOCATION COUNTER BY DA LENGTH
               CW   DA,ACTDA&1         RESET SWITCHES
               B    INSTR              BRANCH TO PROCESS NEW ENTRY
     ACTOUT    MLC  SAVLOC,LOCCTR      RESTORE ORIGINAL LOCATION COUNTER
               B    ACTOUT-11
     *                        PROCESS DA SUBSEQUENT ENTRY
     DASUB     MLC  LOCATN,HOLD        GET RELATIVE POSITION IN AREA
               B    MODALT             APPLY IT TO DA BASE ADDRESS
               MLC  RESULT-1,LOCCTR
               MLC  LOCCTR,LOCATN
               MZ   ACTOP,LOCCTR-1     GET INDEXING FOR LABTBL
               BCE  *&5,LABEL-5,
               B    SETLAB
               B    PUTRCD
     *                        PROCESS GENERATED LITERALS
     LITERL    SBR  LITEXT&3
               BCE  SHORT,PARAMT&6&X1,
     *                        TLU SHORT LITERALS FOR DUPLICATES
     LITOUT    A    PARAMT&29&X1,LITTOT
     LITEXT    B    0
     SHORT     LCA  PARAMT&5&X1,LABTBL-3&X3
               B    TLULAB
               B    INTABL
     FIRST     MLC  LABEL,HLDLAB#6     FIRST OCCURRENCE OF LITERAL
               A    PARAMT&29&X1,LITTOT
               MLC  PARAMT&5&X1,LABEL
               B    SETLAB             PUT SHORT LITERAL IN SYMBOL TABLE
               LCA  LITTOT,LABTBL-9&X3
               SW   LABTBL-17&X3       MARK AS RELATIVE ENTRY
               MLC  HLDLAB,LABEL
               B    LITEXT
     INTABL    SW   LABTBL-8&X3        DUPLICATED SHORT LITERAL
               BWZ  TABLYY,092,2
               B    TABLZZ
     TABLXX    CW   LABTBL-8&X3
               S    PARAMT&29&X1,LITCNT   DUPLICATED WITHIN SAME LITERAL
               MZ   @ @,LITCNT               AREA, NOT PREVIOUS ONE
               BCE  *&12,X1-1,3        SET LITERAL FOR SYMBOLIC TLU
               MLC  @Q@,AADDR
               B    LITEXT
               MLC  @Q@,BADDR
               B    LITEXT
     *                        ALPHANUMERIC LITERAL
     ALFLIT    SBR  LITEXT&3
               C    PARAMT&29&X1,@05@
               BH   SHORT              TEST FOR SHORT A/N LITERAL
               B    LITOUT
     *                        LITERAL AREA OF FORM SYMBOL#10
     AREA      SBR  LITEXT&3
               LCA  PARAMT&9&X1,PARAMT&29&X1
               B    FIRST
     *                        ADDRESS CONSTANT
     ADCON     SBR  LITEXT&3
               B    LITOUT
     *                        TEST FOR CONTROL STATEMENTS
     CNTRL     BCE  ORIGIN,OPER-3,O    ORIGIN CONTROL STATEMENT
               BCE  LTORG,OPER-3,L     LTORG CONTROL STATEMENT
               BCE  EQUATE,OPER-2,Q   EQUATE STATEMENT
               BCE  ELTG,OPER-3,E     EX OR END - PROCESS AS LTORG
               B    PUTRCD            NO PROCESSING REQUIRED
     *                        PROCESS ORIGIN CONTROL STATEMENTS
     ORIGIN    BCE  DECODO,LABEL-5,
               BW   DECODO,FULL
               B    SETLAB
     DECODO    BCE  ACTORG,AADDR,A
               BCE  SYMORG,AADDR,S     SYMBOLIC ADDRESS
               BCE  PUTRCD,AADDR,D     ALREADY PROCESSED
               BCE  SETORG,AADDR,P
               BCE  ASTORG,AADDR,      BLANK OPERAND
               SW   ERRPOS
               B    PUTRCD
     *                        ORIGIN WITH ACTUAL ADDRESS OPERAND
     ACTORG    MLC  @D@,AADDR          MARK AS PROCESSED
               MLC  PARAMT&8,LOCCTR
               MLC  LOCCTR,LOCATN
               B    PUTRCD                 ABSOLUTE MODE
     *                        ORIGIN WITH SYMBOLIC OPERAND
     SYMORG    BCE  ASTORG,PARAMT,*    TEST FOR * OPERAND
               LCA  PARAMT&5,LABTBL-3&X3
               B    TLULAB            TLU SYMBOL IN SYMBOL TABLE
               B    PREVLB             FOUND SYMBOL IN SYMBOL TABLE
     *                        SYMBOL IN OPERAND NOT PREVIOUSLY DEFINED
     NOPREV    BW   PUTRCD&7,FULL
               LCA  @000@,LOCATN
               MLC  @000@,LOCCTR       SET BASE ZERO FOR LOCATION COUNTR
               SW   ERRPOS
               B    PUTRCD
     *                        SYMBOL IN OPERAND WAS PREVIOUSLY DEFINED
     PREVLB    MLC  @P@,AADDR
               MLC  LABTBL&X2,LOCCTR
               MLC  LOCCTR,LOCATN
               BCE  NOSADJ,PARAMT&10,
               MLC  LOCCTR,ADDR
               B    MODADD             APPLY CHARACTER ADJUSTMENT
               MLC  RESULT-1,LOCCTR
     NOSADJ    MLC  LOCCTR,LOCATN
               BW   LTGOUT,LITORG      IF SYMBOLIC LTORG, RETURN TO LTOR
               BW   PUTRCD&7,FULL
               B    PUTRCD
     *                        ORIGIN WITH ASTERISK SYMBOLIC
     ASTORG    C    @&X00@,PARAMT&13  TEST FOR *&X00 OPERAND
               BE   CENORG
               MLC  LOCCTR,ADDR
               BCE  *&12,PARAMT&10,
               B    MODADD             APPLY CHARACTER ADJUSTMENT
               MLC  RESULT-1,LOCCTR
               LCA  LOCCTR,LOCATN
               B    PUTRCD
     *                        ORIGIN WITH *&X00 OPERAND
     CENORG    MLC  @100@,HOLD
               MLC  LOCCTR,ADDR
               B    MODALT
               MN   @000@,RESULT-1     GENERATE NEXT 100S ADDRESS
               MN
               MLC  RESULT-1,LOCCTR
     CEN1      LCA  LOCCTR,LOCATN
     ORGOUT    BW   LTGOUT,LITORG      TEST FOR LTORG SHARING ROUTINE
               B    PUTRCD
     *
     SETORG    MLC  LOCATN,LOCCTR
               B    ORGOUT
     *
     *                        * PROCESS LTORG CONTROL STATEMENTS
     LTORG     BCE  DECODL,LABEL-5,
               BW   DECODL,FULL
               B    SETLAB             STORE LABEL AND PREVIOUS LOCATION
     DECODL    BCE  SYMLTG,AADDR,S     SYMBOLIC ADDRESS
               BCE  ACTLTG,AADDR,A     ACTUAL ADDRESS
               BCE  PUTRCD,AADDR,D     STATEMENT ALREADY PROCESSED
               BCE  SETLIT,AADDR,P
               BCE  ASTLTG,AADDR,      BLANK OPERAND
               SW   ERRPOS            ILLEGAL OPERAND - MARK AS INVALID
               B    PUTRCD
     *                        SYMBOLIC ADDRESS LTORG
     SYMLTG    BCE  ASTLTG,PARAMT,*     TEST FOR * OPERAND
               SW   LITORG            SET LITORG SWITCH FOR ORG ROUTINE
               B    SYMORG             SHARE SYMBOLIC ORG ROUTINE
     LTGOUT    BW   PUTRCD&7,FULL
               MLC  @|@,LABTBL-5&X3
               MLC  LOCCTR,LABTBL-6&X3
               MLC  LOCCTR,ADDR
               MLC  LITTOT,HOLD
               B    MODALT
               MLC  RESULT-1,LOCCTR
               MLC  LITTOT,LABTBL&X3
               MLC  @000@,LITTOT
               MLC  X3,LASTLT          STORE LAST LTORG POINT
     STORLT    CW   LITORG             RESET LITORG SWITCH
               MLC  &PUTRCD,SETEXT&3
               B    TSTLMT            SET ENTRY INTO SYMBOL TABLE
     *                        LTORG WITH * OPERAND
     ASTLTG    C    PARAMT&13,@&X00@   TEST FOR *&X00 OPERAND
               BE   CENLTG
               MLC  LOCCTR,ADDR
               BCE  ELTG,PARAMT&10,
               B    MODADD            APPLY CHARACTER ADJUSTMENT
               MLC  RESULT-1,LOCCTR
     ELTG      LCA  LOCCTR,LOCATN      SET UP TABLE ENTRY
               CW   LABTBL-5&X3
               B    LTGOUT
     CENLTG    SW   LITORG
               B    CENORG
     ACTLTG    MLC  @D@,AADDR
               MLC  PARAMT&8,LOCATN
               MLC  LOCATN,LOCCTR
               B    LTGOUT
     *
     SETLIT    MLC  LOCATN,LOCCTR
               B    LTGOUT
     *
     *                        PROCESS EQUATE ENTRIES
     EQUATE    BCE  SYMEQU,AADDR,S
               BCE  SYMEQU,AADDR,S
               BCE  ACTEQU,AADDR,A
               BCE  MCHEQU,AADDR,M
               BCE  PUTRCD,AADDR,D
               BCE  PROCEQ,AADDR,E
               SW   ERRPOS
               B    PUTRCD
     ACTEQU    MLC  PARAMT&8,ADDR
               B    ADJEQU
     MCHEQU    MLC  PARAMT&2,ADDR
               B    PUTEQU
     ASTEQU    MLC  LOCCTR,ADDR
               ZS   @1@,HOLD
               B    MODALT
               MLC  RESULT-1,ADDR
               B    ADJEQU
     SYMEQU    BCE  ASTEQU,PARAMT,*
               LCA  PARAMT&5,LABTBL-3&X3
               B    TLULAB
               B    HITEQU
               BW   PUTRCD&7,FULL
               SW   ERRPOS-2
               MLC  @###@,LOCATN
               B    PUTRCD
     HITEQU    BW   ADJEQU,LABTBL-8&X2
               MLC  LABTBL&X2,ADDR
               MLC  @E@,AADDR
     ADJEQU    MLC  @000@,X2
               MLC  @000@,X1
               BCE  PUTEQU,PARAMT&10,
               BCE  INDEQU,PARAMT&11,X
               B    MODADD
               MLC  RESULT-1,ADDR
               MLC  @010@,X2
               BCE  PUTEQU,PARAMT&20,
     INDEQU    MLC  @000@,X1
               MN   PARAMT&12&X2,X1
               MZ   ZONE&X1,ADDR-1
     PUTEQU    MLC  ADDR,LOCATN
               MLC  &PUTRCD,SETEXT&3
               BW   PUTRCD&7,FULL
               MLC  LABEL,LABTBL-3&X3
               MLC  ADDR,LABTBL&X3
               B    TSTLMT
     PROCEQ    MLC  LOCATN,ADDR
               B    PUTEQU
     *
     *                        END OF REEL ON INPUT TAPE # 2
     IPEOR     RWD  2
               WTM  1
               RWD  1
               MLC  @4@,SEEK
               CW   PARTBL&90,LABTBL&X3
               B    LOAD
               H
     *                        END OF REEL ON OUTPUT TAPE # 1
     *                                ** IMPOSSIBLE CONDITION **
     *
     *                        TAPE RECORD AREA
     *
     RECORD    DA   1X80,|
     PARTBL    DA   1X90,|
     AADDR          1,1
     BADDR          2,2
     ERRPOS         6
     ICOUNT         7,7
     LITCNT         8,10
     ACTOP          11,11
     LOCATN         12,14
     PARAMT         15,15
     AOPND          85,87
     BOPND          88,90
     OPER      EQU  RECORD&18
     GPMK      DC   @}@
     ZONE      DCW  #1
               DCW  @/JA@
     *
     *                        HOUSEKEEPING ROUTINE - OVERLAID BY TAPE IO
     *
               ORG  RECORD
     HSKPG     MLC  @333@,LOCCTR
               MLC  @000@,X3
               LCA  @000@,LTTSAV
               CW   DA,FULL
     *                        HSKPG ENTRY POINT FOR PHASE 7 REITERATION
     HSKPG1    SW   3998
               LCA  3998,PARTBL&90
               NOP  000
               NOP
               MLC  LTTSAV,LITTOT      REESTABLISH CUTOFF LITERAL TOTAL
               LCA  @000@,LASTLT       SET LAST LITERAL POINT AS ZERO
     *                        CLEAR ALL SWITCHES FOR PHASE 3 OR 7
               SW   RELATV
               CW   LITORG,NEG
               CW   LITCTL,HIGH3&1
               B    GETRCD
               H
     *
     *                        LITERALS USED BY 2TAP2
               LTORGHALT4
     HIGH1     H
     *
     *
     *                        LABEL TABLE FOR 2TAP2
     *                           * SYMBOL STORED IN FIRST 6 POSITIONS
     *                           * EQUIVALENT ADDRESS STORED IN LAST 3
     *                           * FOR RELATIVE ADDRES, W/M UNDER H.O.
     *                           * NUMERIC LITERALS UNDER 6 CHARACTERS
     *                           * ALPHANUMERIC LITERALS UNDER 5 CHARS
     *                           * RELATIVE ORIGIN ENTRY STORED WITH 3
     *                             POSITION ADJUSTMENT VALUE IN FIRST 3
     *                             AND SYMBOLIC  OPERAND IN LAST 6 WITH
     *                             A W/M UNDER FIRST & FOURTH POSITIONS
               ORG  HIGH3&4
     LABTBL    DC   @         @
     3998      DCW  @}@
     *
               ORG  3889
     LOADXX    LCA  ADDR,018
               B    SETEXT
               ORG  3900
     MOVXX     MLC  018,ADDR
               B    PUTRCD&7
               ORG  2758
     TABLYY    BWZ  TABLZZ&8,007,2
               B    TLUFST&8
     TABLZZ    BWZ  TABLXX,007,2
               C    X2,009
               BH   TLUFST&8
               B    TABLXX
               EX   SYSTEM
               JOB  1401 TWO-TAPE AUTOCODER - PHASE 7 - REITERATION  RBR   2TAP7
     *
     ******    OVERLAY OF PHASE 3 FOR REITERATION  ***
     *
     *                        ***  PHASE 7 IDENTIFICATION AT 333  ***
     *
               ORG  333
               DCW  @7@
               B    HSKPG1
     *
     2802      DCW  @}@
               EX   SYSTEM
               JOB  1401 TWO-TAPE AUTOCODER - PHASE 4 - COMPLETE TBL RBR   2TAP4
     *
     ******    TEST SYMBOL TABLE FOR RELATIVE ADDRESSES  ***
     *
     *                        ***  PHASE 4 IDENTIFICATION AT 333  ***
     *
               ORG  333
               DCW  @4@
     *
     TSTTBL    CW   REITER
               BW   TBLDON,RELATV
               SW   RELATV,HOLDZN#1
               MLC  @000@,X1
               MLC  @000@,SAVLOC
               SW   LABTBL-5&X3,LABTBL-8&X3
               BW   *&12,LABTBL-5&X1
     P2SK1     A    @9@,X1
               B    *-18
               C    X1,X3
               BE   TBLDON
               MLC  @000@,X2
               LCA  LABTBL&X1,LABTBL-3&X3
     P2SK2     C    LABTBL-3&X2,LABTBL&X1
               BE   *&12
               A    @9@,X2
               B    P2SK2
               C    X3,X2
               BE   NOSYM
               BW   *&5,LABTBL-8&X2
               B    *&21
               BW   *&5,FULL
               B    NOSYM
               CW   RELATV
               B    P2SK1
               MLC  LABTBL&X2,ADDR
               MLC  LABTBL-6&X1,HOLD
               CW   LABTBL-5&X1
               A    @1@,SAVLOC
               B    MODALT
     P2SK3     MLC  RESULT-1,ADDR
               MLC  ADDR,LABTBL&X1
               CW   LABTBL-5&X1
               MLC  @|@,LABTBL-8&X1
     P2SK4     A    @9@,X1
               BCE  SKPEQU,LABTBL-2&X1,#
               BW   P2SK4,LABTBL-2&X1            BYPASS SHORT LITERALS
               BW   APPLY,LABTBL-8&X1            RELATIVE ADDRESS
               BW   *&21,LABTBL-5&X1
               BW   P2SK4,LABTBL&X1
               BCE  P2SK4,LABTBL-5&X1,|
               B    P2SK1-15
               BCE  SETLOC,LABTBL-5&X1,*
               B    P2SK1-15
     SKPEQU    BW   *&8,LABTBL&1X1
               A    @9@,X1
               B    P2SK4
     SETLOC    MLC  LABTBL-6&X1,HOLD
               B    MODALT
               BCE  CENAPL,LABTBL-4&X1,X
               MLC  RESULT-1,LABTBL&X1
               CW   LABTBL-5&X1
               MLC  RESULT-1,ADDR
               MLC  @|@,LABTBL-8&X1
               B    P2SK4
     CENAPL    MN   @000@,RESULT-1
               MN
               B    SETLOC&19
     APPLY     C    X1,X3
               BE   P2SK8
               BCE  P2SK9,LABTBL-5&X1,|
               BCE  P2SK10,LABTBL-11&X1,#
               MZ   LABTBL-1&X1,HOLDZN
               MLC  LABTBL&X1,HOLD
               B    MODALT
               MLC  RESULT-1,LABTBL&X1
               MZ   HOLDZN,LABTBL-1&X1
               CW   LABTBL-8&X1
               B    P2SK4
     P2SK9     MLC  LABTBL-6&X1,HOLD
               B    MODALT
               BCE  CNLAPL,LABTBL-4&X1,X
               MLC  RESULT-1,LABTBL-6&X1
               MLC  RESULT-1,ADDR
               MLC  LABTBL&X1,HOLD
               B    MODALT
               MLC  RESULT-1,ADDR
               B    P2SK9-8
     CNLAPL    MN   @000@,RESULT-1
               MN
               B    P2SK9&19
     P2SK10    MLC  LABTBL-6&X1,HOLD
               B    MODALT
               MLC  RESULT-1,LABTBL-6&X1
               B    P2SK9-8
     NOSYM     BW   P2SK7,FULL
               MLC  @000@,ADDR
               MLC  ADDR,LABTBL&X1
               SW   LABTBL-7&X1
               B    P2SK3&7
     P2SK7     CW   RELATV
               A    @9@,X1
               B    P2SK1-15
     TBLDON    BW   *&13,RELATV
               C    SAVLOC,@000@
               BU   TSTTBL
               BW   *&5,FULL
               B    TSTLIT
               SW   REITER
               B    TSTLIT
     P2SK8     BW   *&5,OVFLIT-8
               B    TBLDON
               MLC  OVFLIT-6,HOLD
               B    MODALT
               MLC  RESULT-1,OVFLIT-6
               CW   OVFLIT-8
               B    TBLDON
     *                        TEST TABLE FOR UNDEFINED LITORG ENTRIES
     TSTLIT    MLC  @000@,X1
               SW   LABTBL&X3
     CMPLTG    BW   *&12,LABTBL&X1
               A    @9@,X1
               B    CMPLTG
               C    X1,X3
               BE   TSTEQU
               BCE  CMPLTG&8,LABTBL-5&X1,*
               CW   LABTBL&X1
               SW   LABTBL-5&X1
               LCA  LABTBL&X1,LABTBL-3&X3
               CW   LABTBL-5&X1
               SW   LABTBL&X1
               B    TLULAB
               B    LITHIT
     NLTHIT    BW   *&5,RELATV
               B    CMPLTG&8
               MLC  @|@,LABTBL-5&X1
               MLC  @000@,LABTBL-6&X1
               B    CMPLTG&8
     LITHIT    BW   NLTHIT,LABTBL-8&X2
               SW   LABTBL-8&X1
               MLC  LABTBL&X2,LABTBL-6&X1
               CW   LABTBL-8&X1,LABTBL&X1
               MLC  @|@,LABTBL-5&X1
               B    CMPLTG&8
     *                        TEST TABLE FOR UNDEFINED EQUATE ENTRIES
     TSTEQU    MLC  @000@,X1
               MLC  @#@,LABTBL-2&X3
     CMPEQU    BCE  *&12,LABTBL-2&X1,#
               A    @9@,X1
               B    CMPEQU
               C    X1,X3
               BE   SHRTLT
               BCE  *&5,LABTBL&4&X1,
               B    TLUEQU
               BW   CMPEQU&8,LABTBL&1&X1
               SW   LABTBL-2&X1
               BW   *&5,LABTBL-1&X1
               B    *&8
               MZ   LABTBL-1&X1,LABTBL&2&X1
               MLC  LABTBL&3&X1,LABTBL&X1
               CW   LABTBL-2&X1
               MLC  @|@,LABTBL&2&X1
               B    CMPEQU&8
     TLUEQU    SW   LABTBL&4&X1
               MLC  LABTBL&9&X1,LABTBL-3&X3
               CW   LABTBL&4&X1
               B    TLULAB
               B    PRVEQU
               BW   *&5,RELATV
               B    CMPEQU&8
               MLC  @###@,LABTBL&X1
               B    CMPEQU&8
     PRVEQU    BW   *&8,LABTBL-1&X1
               MZ   LABTBL-1&X2,LABTBL-1&X1
               CW   LABTBL-1&X1
               MZ   LABTBL-1&X1,HOLDZN
               MLC  LABTBL&X2,ADDR
               MLC  LABTBL&3&X1,HOLD
               B    MODALT
               MLC  RESULT-1,LABTBL&X1
               MZ   HOLDZN,LABTBL-1&X1
               CW   LABTBL&4&X1
               CW   LABTBL-8&X1,LABTBL-2&X1
               MLC  @|@,LABTBL&2&X1
               B    CMPEQU&8
     *                        COMPLETE SHORT LITERAL ADDRESSES
     SHRTLT    MLC  @000@,X1
               MLC  @000@,X2
     TSTLTG    BCE  HAVLTG,LABTBL-5&X2,|
               A    @9@,X2
               C    X3,X2
               BE   ENDPH2
               B    TSTLTG
     HAVLTG    MLC  LABTBL-6&X2,ADDR
               ZS   @1@,HOLD
               B    MODALT
               MLC  RESULT-1,ADDR
     TSTSRT    BW   HAVSRT,LABTBL-2&X1
               A    @9@,X1
               C    X1,X3
               BE   ENDPH2
               B    TSTSRT
     HAVSRT    C    X2,X1
               BH   PATCHX
               MLC  LABTBL&X1,HOLD
               B    MODALT
               MLC  RESULT-1,LABTBL&X1
               CW   LABTBL-8&X1
               B    TSTSRT&8
     ENDPH2    LCA  @         @,LABTBL&X3
               CW   LABTBL-8&X3
               MLC  @5@,SEEK
               CW   HIGH2&1
               NOP  999,999
               B    LOAD
               H
               LTORGNEG&1
               H
     PATCHX    BWZ  TSTLTG&8,092,2
               BWZ  HAVSRT&12,087,2
               B    TSTLTG&8
     HIGH2     H
               DCW  @}@
               EX   SYSTEM
               JOB  1401 TWO-TAPE AUTOCODER - PHASE 5 - TLU LABELS   RBR   2TAP5
     *
     ******    PHASE 5 - TLU LABELS AND PROCESS LITERAL RECORDS  ***
     *
     *                        ***  PHASE 5 IDENTIFICATION AT 333  ***
     *
               ORG  333
               DCW  @5@
     *
               B    PHASE5             BRANCH TO HOUSEKEEPING
     *
               ORG  RECORD&1
     PHASE5    CW   SAVLIT#1,ADONE#1   HOUSEKEEPING
               SW   3998
               LCA  3998,PARTBL&90
               CW   FSTIME#1,DOUBLE#1
               CW   LITONE#1,LITX#1
               CW   LITORG
               NOP  LITBEG#5,ORGBAS#3
               NOP  TEMP1#3
               MLC  @   @,ADDR
               MLC  @000@,LSTORG#3
               MLC  @000@,LASTLT
               MLC  X3,BASIC#3
               MLC  @000@,X3
               B    TLULIT
               H
               ORG  338
     *                        FIND FIRST LTORG ENTRY IN LABEL TABLE
     TLULIT    C    X3,BASIC
               BE   HITLIT-8           HAVE OVERFLOW LTORG
               A    @9@,X3             STEP X3 TO FIND NEXT LTORG IN TBL
               BCE  HITLIT,LABTBL-5&X3,|       TEST FOR LTORG ENTRY
               B    TLULIT
               SW   LITADD             SET UP FOR INCOMPLETE LTORG
               B    LITPNT&7
     HITLIT    MLC  LABTBL-6&X3,ADDR
               MLC  @00J@,HOLD
               B    MODALT
     *                        SET LTORG POINT ADDRESS IN LITADD
     LITPNT    LCA  RESULT-1,LITADD#3    SET UP START ADDR OF LITERALS
               MLC  X3,LITLOC#3
               MLC  BASIC,X3
     *                        GET INPUT RECORD FOR PROCESSING
     GET       RTW  1,RECORD
               BER  TPERR
               BEF  ENDPH3
               BCE  PUT,RECORD&5,*
               CW   ADONE
               C    OPER,@LTOR@
               BE   LIT
               C    OPER,@EX  @
               BE   LTDONE
               BW   HAVLIT,LITX
               BW   LITRCD,RECORD&3
     LTREST    MLC  LITBEG-2,LASTLT
               CW   LITORG
               BW   CONTRL,RECORD
     TEST      BCE  DECL,ICOUNT,
     *                        PROCESS IMPERATIVE INSTRUCTION
               MLC  @000@,HOLD
               MLC  PARAMT&29,HOLD
               MLC  @000@,X1
               MLC  AADDR,DADDR#1
               BCE  DONE,AADDR,
               BCE  OUTADD&15,AADDR,D
               BCE  SYMBOL,AADDR,S
               BCE  ACTUAL,AADDR,A
               BCE  MACHIN,AADDR,M
               BCE  CNVRTD,AADDR,Q
               BW   OUTADD,LITADD
     *                        SET UP ADDRESS FOR LITERAL
     LITRAL    MLC  LITADD,ADDR
               B    MODALT
               MLC  RESULT-1,ADDR
               MLC  ADDR,LITADD
               MLC  @D@,DADDR
               SW   SAVLIT
     OUTADD    BW   DOBADD,ADONE
               MLC  ADDR,AOPND
               B    SETXX
               MLC  PARAMT&59,HOLD
               MLC  @030@,X1
               MLC  DADDR,AADDR
               MLC  BADDR,DADDR
               BW   ALIT,SAVLIT
     TSTADD    BCE  DONE,BADDR,
               BCE  DONE,BADDR,D
               BCE  SYMBOL,BADDR,S
               BCE  ACTUAL,BADDR,A
               BCE  MACHIN,BADDR,M
               BCE  CNVRTD,BADDR,Q
               BCE  DONE,ICOUNT,
               B    LITRAL-8
     ALIT      CW   SAVLIT
               B    TSTADD
     *                        PROCESS LITERAL RECORD
     HAVLIT    CW   LITX
               BW   *&5,RECORD&3
               B    LTREST
               MLC  TEMP1,X1
               B    LITRCD&15
     LITRCD    BW   PROCSW,LITORG
               MLC  LITLOC,X1
               SW   LITORG
               C    X1,X3
               BE   NOPROC
               BW   NOPROC,LABTBL&X1
               BW   NOPROC,LABTBL-8&X1
               B    *&12
     NOPROC    MLC  @B@,PROCSW
               B    PROCSW
               MLC  @N@,PROCSW
               MLC  LABTBL-6&X1,ADDR
               ZS   @1@,HOLD
               B    MODALT
               MLC  RESULT-1,BASE#3
     PROCSW    NOP  TSTADC
               BW   TSTADC,RECORD&4
               BCE  ALPHA,RECORD&20,@
               BCE  NUMLIT&8,PARAMT&60,A
     NUMLIT    BCE  SHORTL,PARAMT&6,
               MLC  BASE,ADDR
               MLC  LITCNT,HOLD
               B    MODALT
               LCA  RESULT-1,LOCATN
               MLC  LOCATN,BASE
               SW   RECORD&4           MARK LITERAL RECORD AS PROCESSED
     TSTADC    BCE  TLUADC,PARAMT&61,D
               B    PUT
     TLUADC    BCE  PUT,AADDR,D
               MLC  AADDR,DADDR
               MLC  @000@,X1
               SW   PARAMT&1
               LCA  PARAMT&6,LABTBL-3&X3
               B    SYMBOL&15
     LADBCK    MLC  AOPND,PARAMT&32
               B    PUT
     SHORTL    SW   PARAMT
               LCA  PARAMT&5,LABTBL-3&X3
               B    TLULAB
               B    *&5
               B    PUT
               SW   LABTBL-8&X3
               C    X2,LASTLT
               B    ADJXX
               NOP
               CW   LABTBL-8&X3
               BW   ALPHA-8,LABTBL-2&X2
               B    GET
               CW   LABTBL-2&X2
               B    NUMLIT&8
     ALPHA     C    LITCNT,@005@
               BH   SHORTL
               B    NUMLIT&8
     *                        PROCESS SYMBOLIC LABEL - TLU IN LABEL TABL
     SYMBOL    BCE  ASTRSK,PARAMT&X1,*
               LCA  PARAMT&5&X1,LABTBL-3&X3
               B    TLULAB
               B    HITSYM
               BW   OUTADD,  FULL
               B    TSTFUL
     HITSYM    BW   TSTFUL,LABTBL-8&X2
               CW   LABTBL-2&X2
               MLC  LABTBL&X2,ADDR
               BCE  TSTFUL,LABTBL-2&X2,#
               MLC  @D@,DADDR
               B    CMPADD
     TSTFUL    BW   OUTADD,FULL
               MLC  @###@,ADDR
               SW   ERRPOS-2
               MLC  @D@,DADDR
               B    OUTADD
     ASTRSK    BCE  OUTADD,LOCATN,
               MLC  LOCATN,ADDR
               ZA   ICOUNT,HOLD
               S    @1@,HOLD
               MZ   @ @,HOLD
               B    MODALT
               MLC  RESULT-1,ADDR
               MLC  @D@,DADDR
               B    CMPADD
     *                        PROCESS ACTUAL ADDRESS OPERAND
     ACTUAL    MLC  PARAMT&8&X1,ADDR
               MLC  @D@,DADDR
               B    CMPADD
     *                        PROCESS MACHINE ADDRESS OPERAND
     MACHIN    MLC  PARAMT&2,ADDR
               MLC  @D@,DADDR
               B    OUTADD
     *                        APPLY CHARACTER ADJUSTMENT & INDEXING
     CMPADD    BCE  OUTADD,PARAMT&10&X1,
               BCE  INDADD,PARAMT&11&X1,X
     ADJADD    MLC  @000@,X2
               SW   PARAMT&11&X1
               MLC  PARAMT&19&X1,X2
               A    X1,X2
               MLC  @000@,HOLD
               MLC  PARAMT&10&X2,HOLD
               MZ   PARAMT&10&X1,HOLD
               MZ   ADDR-1,HOLDZN
               B    MODALT
               MLC  RESULT-1,ADDR
               MZ   HOLDZN,ADDR-1
               A    @10@,X1
               BCE  OUTADD,PARAMT&10&X1,
     INDADD    MLC  @000@,X2
               MN   PARAMT&12&X1,X2
               MZ   ZONE&X2,ADDR-1
               B    OUTADD
     DOBADD    MLC  ADDR,BOPND
               CW   ADONE
               MLC  DADDR,BADDR
               BW   BLIT,SAVLIT
     DONE      BCE  LADBCK,PARAMT&61,D
               B    PUT
     BLIT      CW   SAVLIT
               B    DONE
     *                        TLU DUPLICATED SHORT LITERALS
     CNVRTD    LCA  PARAMT&5&X1,LABTBL-3&X3
               B    TLULAB
               B    *&5
               H    *-3
               SW   LABTBL-8&X3
               C    X2,LASTLT
               B    ADJXX
               NOP
               CW   LABTBL-8&X3
               BW   TSTFUL,LABTBL-8&X2
               B    HITSYM&12
     *                        TEST CONTROL ENTRIES
     CONTRL    C    OPER,@EQU @
               BE   GETEQU
               C    OPER,@END @
               BE   LTDONE
               MLC  @000@,X1
               C    OPER,@XFR @
               BE   TEST&22
               B    PUT
     *                        PROCESS EQUATE ENTRIES
     GETEQU    B    PUT
     *                        PROCESS LTORG ENTRIES
     LIT       SW   LITX
     LTDONE    BW   LITBCK-12,RECORD&4
               MLC  &LITBCK,OUT&3
               C    LITLOC,X3
               BE   LIT1
               BW   *&9,LOCATN
               SW   RECORD&4
               B    LITBCK-12
               MLC  LITLOC,X1
               BW   LIT1,LABTBL-8&X1
               BW   LIT1,LABTBL&X1
               CW   LOCATN
               MLC  LABTBL-6&X1,LOCATN
               BCE  CALLTT,PARAMT,*
               BCE  CALLTT,OPER-3,E
               B    LIT1-8
     CALLTT    MLC  LOCATN,ADDR
               MLC  LABTBL&X1,HOLD
               B    MODALT
               MLC  RESULT-1,ORGBAS
               SW   RECORD&4           MARK LTORG AS PROCESSED
               B    LITBCK-12
     LIT1      BW   LITBCK-12,FULL
               SW   ERRPOS
               LCA  @000@,LOCATN
               BCE  TEST&22,OPER-3,E
               B    PUT
     LITBCK    MLC  &GET,OUT&3
               MLC  X3,BASIC
               MLC  LITLOC,LITBEG-2
               BW   *&8,LITX
               MLC  LITLOC,LASTLT
               MLC  LITLOC,X3
               MLC  LITLOC,TEMP1
               B    TLULIT
     *                        DECLARATIVE ENTRIES - BYPASS IF CONSTANT
     *                             IF ADDRESS CONSTANT, LOOK IT UP
     DECL      BCE  TLUADC,AADDR,C
               BCE  TEST&22,AADDR,S
               BCE  TEST&22,AADDR,A
               B    PUT
     *                        MARK LITERAL RECORD AS PROCESSED
     PUTX      SW   RECORD&4
     *                        PUT A RECORD
     PUT       WTW  2,RECORD
               BER  TPERR
               BEF  *&1
     OUT       B    GET
     ENDPH3    RWD  1
               WTM  2
               RWD  2
               BW   *&19,REITER
               MLC  @8@,SEEK
               NOP  666,666
               B    *&15
               MLC  @8@,SEEK
               NOP  555,555
               CW   PARTBL&84
               CW   BOPND&1
               CW   HIGH3&1,GPMK
               B    LOAD
     HIGHPT    H
     SETXX     MLC  @000@,HOLD
               SW   ADONE
               B    OUTADD&19
               ORG  HIGH2&1
               DCW  #1
               LTORGHOLDZN&1
     HIGH3     H
               DCW  @}@
               ORG  LITBEG-2
               DCW  @000@
               ORG  1924
     ADJXX     SBR  ADJYY-1
               BWZ  ADJYY,092,2
               BWZ  ADJYY-4,007,2
               BH   TLUFST&8
               B    000
     ADJYY     BWZ  ADJYY-9,007,2
               B    TLUFST&8
               EX   SYSTEM
               JOB  1401 TWO-TAPE AUTOCODER - PHASE 6 - PACK TABLE   RBR   2TAP6
     *
     ******    PHASE 6 - CONDENSING OF RELATIVE ENTRIES IN SYMBOL TABLE
     *                            FOR REITERATION
     *
     *                        ***  PHASE 6 IDENTIFICATION AT 333  ***
     *
               ORG  333
               DCW  @6@
     *
     RERUN     MLC  @000@,X1
               MLC  @000@,X2
     AVAIL     BW   SAVE1,LABTBL-5&X1
               BW   SAVE1,LABTBL-2&X1
               BW   SAVE1,LABTBL&X1
               BW   SAVE,LABTBL-8&X1
               BCE  SAVE4,LABTBL-2&X1,#
     AVAIL1    C    X1,X3
               BE   PACKED
               A    @9@,X1
               B    AVAIL
     SAVE      B    CMP1T2
               LCA  LABTBL&X1,LABTBL&X2
               CW   LABTBL-8&X1
               A    @9@,X2
               B    AVAIL1
     SAVE1     B    CMP1T2
               BW   SAVE2,LABTBL-8&X1
               SW   LABTBL-8&X1
               LCA  LABTBL&X1,LABTBL&X2
               MLC
     SAVE3     LCA  @         @,LABTBL&X1
               B    SAVE&11
     SAVE2     LCA  LABTBL&X1,LABTBL&X2
               LCA
               B    SAVE3
     SAVE4     B    CMP1T2
               A    @9@,X2
               SW   LABTBL-8&X1
               MLC  LABTBL&9&X1,LABTBL&X2
               B    SAVE&11
     *
     CMP1T2    SBR  CMPEXT&3
               C    X1,X2
     CMPEXT    BU   0
               A    @9@,X2
               B    AVAIL1
     *
     PACKED    MLC  X2,X3
               CW   HIGH5
               MLC  @7@,SEEK
               NOP  777,777
               B    LOAD
               LTORG*
     HIGH5     DCW  @}@
               H
               ORG  HIGH1
               DCW  @|@
               ORG  HIGH3&1
               DCW  #1
               EX   SYSTEM
               END  SYSTEM
